# crick57
"""
print dir(pizzaGrammar)
print pizzaGrammar.ToString()
for i in dir(pizzaGrammar):
    print i, getattr(pizzaGrammar, i)

from System.Speech.Recognition import SpeechRecognizer, Choices, Grammar, GrammarBuilder

pizzaChoices = Choices()
pizzaChoices.Add("Shields");
pizzaChoices.Add("Fire");

builder = GrammarBuilder("Default")
builder.Append(pizzaChoices)
pizzaGrammar = Grammar(builder)

def shields(o, e):
    print 'Shields!'
    
pizzaGrammar.SpeechRecognized += shields

_recognizer = SpeechRecognizer()
_recognizer.LoadGrammar(pizzaGrammar)
_recognizer.Enabled = True

_recognizer.SpeechHypothesized += shields

"""
import clr
import sys

clr.AddReferenceByPartialName("PresentationFramework")
clr.AddReferenceByPartialName("PresentationCore") # for SizeToContent
clr.AddReferenceByPartialName("System.Drawing")
clr.AddReferenceByPartialName("System.Messaging")
clr.AddReferenceByPartialName("System.Windows.Forms")
clr.AddReferenceByPartialName("WindowsBase")
clr.AddReferenceByPartialName('System.Speech')

from System.Windows import Application, Window, SizeToContent, Visibility
from System.Windows.Forms import Timer
from System.Windows.Input import Key
from System.Windows import Point, Rect, Size, WindowStartupLocation

from loadxaml import load_xaml
from playareaitem import PlayAreaItem

application = Application()
window = Window()

window.Content = load_xaml(sys.argv[1])
window.SizeToContent = SizeToContent.WidthAndHeight
window.WindowStartupLocation = WindowStartupLocation.CenterScreen

play_grid = window.Content.FindName("PlayGrid")

pause_indicator = window.Content.FindName("PauseIndicator")
left_paddle_element = window.Content.FindName("LeftPaddle")
left_paddle_area = window.Content.FindName("LeftPaddleArea")

right_paddle_element = window.Content.FindName("RightPaddle")
right_paddle_area = window.Content.FindName("RightPaddleArea")

right_lose_area = PlayAreaItem(
    window.Content.FindName("RightLoseArea"), play_grid)
left_lose_area = PlayAreaItem(
    window.Content.FindName("LeftLoseArea"), play_grid)

from ball import Ball
from paddle import Paddle

balls = []
for i in range(1, 1000):
    ball_element = window.Content.FindName("Ball%d" % i)
    if ball_element is None:
        break

    ball = Ball(play_grid, ball_element)
    balls.append(ball)
    
left_paddle = Paddle(play_grid, left_paddle_area, left_paddle_element)
right_paddle = Paddle(play_grid, right_paddle_area, right_paddle_element)

class PongController(object):
    def __init__(self, window):
        self.window = window
        self.Pause = True

        self.window.KeyDown += self.down
        self.window.KeyUp += self.up

        self.last_keys = set()    
        
        self.score_element = window.Content.FindName("Score")
        self.left_score = 0
        self.right_score = 0
        
        self.tick(None, None)
        self.tick(None, None)
        self.tick(None, None)
        self.tick(None, None)
        self.tick(None, None)

        self.timer = Timer()
        self.timer.Tick += self.tick
        self.timer.Interval = int(1000 / 40.0);
        self.timer.Start()
        
    def down(self, o, e):
        if e.Key == Key.P:
            self.Pause = not self.Pause
            if self.Pause:
                pause_indicator.Visibility = Visibility.Visible
            else:
                pause_indicator.Visibility = Visibility.Hidden
                
        self.last_keys.add(e.Key)
    
    def up(self, o, e):
        self.last_keys.remove(e.Key)

    def tick(self, o, e):
        if self.Pause:
            return
        
        for last_key in self.last_keys:
            if last_key == Key.Q:
                left_paddle.move_up()
            elif last_key == Key.A:
                left_paddle.move_down()
            elif last_key == Key.Down:
                right_paddle.move_down()
            elif last_key == Key.Up:
                right_paddle.move_up()        
    
        for ball in balls:
            ball.move()
#            print ball.degree_angle, ball.velocity, ball.angle, ball.dx, ball.dy
            
            if ball.get_play_rect().IntersectsWith(left_paddle.get_play_rect()):
                if ball.dx < 0:
                    ball.x_bounce()
#                    ball.velocity += 1
            elif ball.get_play_rect().IntersectsWith(right_paddle.get_play_rect()):
                if ball.dx > 0:
                    ball.x_bounce()      
#                    ball.velocity += 1
            elif ball.get_play_rect().IntersectsWith(
                            right_lose_area.get_play_rect()):
                self.left_score += 1
                ball.reset()
            elif ball.get_play_rect().IntersectsWith(
                            left_lose_area.get_play_rect()):
                self.right_score += 1
                ball.reset()
                
#            self.ball.ActualWidth / 2 + self.play_area.ActualWidth / 2
            
            """
            t = left_paddle_element.TransformToVisual(play_grid)
            print t.TransformBounds(Rect(0, 0, left_paddle_element.ActualWidth, left_paddle_element.ActualHeight))
            
            
            if ball.right_X > right_paddle.left_X:
                if not ((ball.bottom_Y > right_paddle.top_Y) and
                        (ball.top_Y < right_paddle.bottom_Y)):
                    if ball.dx > 0:
                        ball.x_bounce()      
            elif ball.left_X > right_paddle.right_X:
                self.right_score += 1
                ball.reset()
            """
        
        self.score_element.Content = "%d : %d" % (
                        self.left_score, self.right_score)


controller = PongController(window)
application.Run(window)